
async function init() {
    try {

        connection = await wh.get(`iip://${window.location.hostname}`, {
            autoReconnect: true
        });

        window.service = await connection.get("sys/service");

        await app.setData(connection);
        console.log(connection);


     }
    catch (ex)
    {
        alert(ex);
    }
}

async function addJob() {
    let cmd = prompt("Job command", "");

    if (cmd != null) {
        try {
            await service.Compute(cmd, "");
        } catch (ex) {
            alert(ex);
        }
    }

    document.getElementById("list").update();
}

async function addAgent() {
    let ip = prompt("Agent IP or hostname", "");

    if (ip != null) {
        try {
            await service.AddAgent(ip);
        } catch (ex) {
            alert(ex);
        }
    }

    document.getElementById("list").update();

}

const FORMAT_CONNECTION_STATUS = (x) => ["Offline", "Connecting...", "Online"][x];

const FORMAT_TIME = (x) => {
    x = x / 1000;

    var hours = Math.floor(x / 3600);
    var minutes = Math.floor((x - (hours * 3600)) / 60);
    var seconds = x - (hours * 3600) - (minutes * 60);

    if (hours < 10) { hours = "0" + hours; }
    if (minutes < 10) { minutes = "0" + minutes; }
    if (seconds < 10) { seconds = "0" + seconds; }
    return hours + ':' + minutes + ':' + seconds;
 }